<template>
  <div class="examination-analysis">
    <div class="box-list">
      <div v-for="(item , index) in cardData" :key="index" class="box">
        <el-card class="box-card" v-bind:class="{ 'box-last': index == 2 }">
          <!-- <div class="box-center"> -->
          <p class="value">{{ item.value }}</p>
          <p class="title">{{ item.title }}</p>
          <!-- </div> -->
        </el-card>
      </div>
    </div>
    <div class="spacing"></div>
    <div class="chart-title">完成项目考试次数情况</div>
    <div class="chart" id="examTimes" ref="examTimes"></div>
    <div class="chart-remarks">注：本报表数据来源包括用户参加正式考试次数，不包含摸底考试次数。</div>
    <div class="spacing"></div>
    <!-- <div class="chart-title">完成项目考试分数情况</div> -->
    <div class="chart-title-more">
        <p>完成项目考试分数情况</p>
        <el-radio-group  class="rank-radio" size="medium" v-model="rankType" @change="changeRank">
          <el-radio-button label="1">1分</el-radio-button>
          <el-radio-button label="5">5分</el-radio-button>
          <el-radio-button label="10">10分</el-radio-button>
        </el-radio-group>
      </div>
    <div class="chart" id="examScore" ref="examScore"></div>
    <div class="chart-remarks">注：本报表数据来源包括用户参加正式考试，不包含摸底考试。</div>
    <div class="spacing"></div>
    <el-table :data="tableData" border class="exam-table">
      <el-table-column prop="examType" label="类型" align="center"></el-table-column>
      <el-table-column prop="examName" label="考试名" min-width="150" align="center"></el-table-column>
      <el-table-column prop="doctorCount" label="应参与考试人数" align="center"></el-table-column>
      <el-table-column prop="passCount" label="通过考试人数" align="center"></el-table-column>
      <el-table-column prop="passRate" label="整体通过率" align="center">
        <template slot-scope="scope">{{ scope.row.passRate | examRate }}</template>
      </el-table-column>
      <el-table-column prop="joinCount" label="参与考试人数" align="center"></el-table-column>
      <el-table-column prop="joinRate" label="参与通过率" align="center">
        <template slot-scope="scope">{{ scope.row.joinRate | examRate }}</template>
      </el-table-column>
      <el-table-column label="操作" fixed="right" align="center" min-width="100">
        <template slot-scope="scope">
          <el-button class="button-jump" type="text" size="small" @click="goPage(scope.row)">查看名单</el-button>
        </template>
      </el-table-column>
      <div slot="empty">
        <div class="table-empty">
          <img src="../../assets/image/no-content1.png" />
          <p>没有相关数据，请重新选择查询范围</p>
        </div>
      </div>
    </el-table>
    <!-- 分页 -->
    <div class="pagination">
      <el-pagination
        class="pagination"
        background
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page="pageNo"
        :page-sizes="[20, 50 ,100]"
        :page-size="pageSize"
        layout="total, sizes, prev, pager, next, jumper"
        :total="totalRows"
      ></el-pagination>
    </div>
  </div>
</template>

<script>
import { log } from "util";
import { openLoading, closeLoading } from "../../utils/utils";
import * as commonUtil from "../../utils/utils";
import * as operationData from "../../utils/operation";
import * as chartData from "../../utils/learning/chartData";
import echarts from "echarts";
let vm;
export default {
  props: {
    formInline: {
      type: Object
    },
    activeName: {
      type: String
    },
    dialogData: {
      type: Object
    },
    organizationList: {
      type: Array
    }
  },
  data() {
    return {
      projectId: "",
      tableData: [],
      cardData: [],
      totalRows: 0, //数据总数
      pageNo: 1, //当前是第几页
      pageSize: 20, //页面总数
      labelTd: [],
      showTd: [false, false, false, false],
      echartsData: {
        chart0: {},
        chart1: {}
      },
      examData: {},
      rankType: '1',
    };
  },
  created() {
    vm = this;
    this.projectId = vm.getUrlSearch(window.location.href, "id");
  },
  // 挂载到Dom完成时
  mounted: function() {
    this.$on("search", () => {
      // console.log(this.formInline);
      this.pageNo = 1;
      this.search();
      this.searchTable();
    });
    this.$on("init", () => {
      this.$nextTick(function() {
        if (vm.formInline.region.length != 0) {
          this.search();
          this.searchTable();
        }
      });
    });
    this.$on("reset", () => {
      this.pageNo = 1;
      this.pageSize = 20;
      this.tableData = [];
      this.cardData = [];
    });
  },
  methods: {
    // 搜索列表
    search() {
      let checkAll = operationData.hasAll(vm.formInline.organization);
      let req = {
        projectId: vm.projectId,
        beginDate: operationData.setDuringTime(vm.formInline.during, "begin"),
        endDate: operationData.setDuringTime(vm.formInline.during, "end"),
        hospitalIdList: vm.formInline.organization,
        originalFlag: vm.formInline.checked == false ? 0 : 1,
        regionId: vm.formInline.region[vm.formInline.region.length - 1],
        timeFlag: vm.formInline.timeFlag
      };
      // console.log("4 req", req);
      openLoading(vm);
      vm.POST("stats/report/exam", req).then(res => {
        closeLoading(vm);
        if (res.code == "000000") {
          vm.examData = res.data;
          vm.setCardData(res.data);
          vm.setExamTimes(res.data.examTimesList);
          vm.setExamScore(res.data.examScoreList);
        } else {
          vm.$message(res.message);
        }
      });

      // let reqList = req;
      // reqList.pageNo = vm.pageNo;
      // reqList.pageSize = vm.pageSize;
      // openLoading(vm);
      // vm.POST("stats/report/exam/list", req).then(res => {
      //   closeLoading(vm);
      //   if (res.code == "000000") {
      //     vm.tableData = res.data.examInfoList;
      //     vm.totalRows = res.data.totalRows;
      //   }
      // });
    },
    searchTable() {
      let req = {
        projectId: vm.projectId,
        beginDate: operationData.setDuringTime(vm.formInline.during, "begin"),
        endDate: operationData.setDuringTime(vm.formInline.during, "end"),
        hospitalIdList: vm.formInline.organization,
        originalFlag: vm.formInline.checked == false ? 0 : 1,
        regionId: vm.formInline.region[vm.formInline.region.length - 1],
        timeFlag: vm.formInline.timeFlag
      };
      let reqList = req;
      reqList.pageNo = vm.pageNo;
      reqList.pageSize = vm.pageSize;
      openLoading(vm);
      vm.POST("stats/report/exam/list", req).then(res => {
        closeLoading(vm);
        if (res.code == "000000") {
          vm.tableData = res.data.examInfoList;
          vm.totalRows = res.data.totalRows;
        }
      });
    },
    setCardData(data) {
      vm.totalRows = data.projectExamCount;
      let cardData = [
        {
          title: "项目正式考试数",
          value: "0门"
        },
        {
          title: "项目摸底考试数",
          value: "0门"
        },
        {
          title: "项目所有考题数",
          value: "0道"
        }
      ];
      cardData[0].value = data.afterExamCount + "门";
      cardData[1].value = data.beforeExamCount + "门";
      cardData[2].value = data.examTitleCount + "道";
      vm.cardData = cardData;
    },
    updateResize() {
      setTimeout(function() {
        window.onresize = function() {
          vm.echartsData.chart0.resize();
          vm.echartsData.chart1.resize();
        };
      }, 30);
    },
    setExamTimes(data) {
      let myChart = echarts.init(this.$refs.examTimes);
      let xAxisData = [];
      let seriesData = [];
      for (let i = 0; i < data.length; i++) {
        xAxisData.push(data[i].times + "次");
        seriesData.push(data[i].count);
      }
      let option = chartData.examTimes(xAxisData, seriesData);
      myChart.setOption(option);
      vm.echartsData.chart0 = myChart;
      vm.updateResize();
    },
    changeRank(value) {
      console.log(value);
      if(value == '1') {
        vm.setExamScore(vm.examData.examScoreList);
      } else if(value == '5') {
        vm.setExamScore(vm.examData.fiveExamScoreList);
      } else if(value == '10') {
        vm.setExamScore(vm.examData.tenExamScoreList);
      }
    },
    setExamScore(data) {
      let myChart = echarts.init(this.$refs.examScore);
      let xAxisData = [];
      let seriesData = [];
      for (let i = 0; i < data.length; i++) {
        xAxisData.push(data[i].timesStr);
        seriesData.push(data[i].count);
      }
      let option = chartData.examScore(xAxisData, seriesData);
      myChart.setOption(option);
      vm.echartsData.chart1 = myChart;
      vm.updateResize();
    },
    // 跳转查看名单页面
    goPage(data) {
      let checkAll = operationData.hasAll(vm.formInline.organization);
      let routerData = {};
      routerData = this.dialogData;
      routerData.projectId = vm.projectId;
      routerData.projectName = vm.getUrlSearch(
        window.location.href,
        "projectName"
      );
      routerData.tableType = 2;
      routerData.examId = data.examId;
      routerData.ids = operationData.getIds(
        vm.formInline,
        vm.organizationList,
        checkAll
      );
      (routerData.type = operationData.getSearchType(vm.formInline, checkAll)),
        (routerData.originalFlag = vm.formInline.checked == false ? 0 : 1);

      // this.$router.push({ path: '/name-list', query: routerData});
      let routeData = this.$router.resolve({
        path: "/name-list",
        query: routerData
      });
      window.open(routeData.href, "_blank");
    },
    // 更改数据显示数量
    handleSizeChange(val) {
      console.log(`每页 ${val} 条`);
      vm.pageSize = val;
      vm.searchTable();
    },
    // 换页
    handleCurrentChange(val) {
      console.log(`当前页: ${val}`);
      vm.pageNo = val;
      vm.searchTable();
    }
  }
};
</script>

<style lang='scss' rel='stylesheet/scss'>
.examination-analysis {
  background: #fff;
  overflow: hidden;
  .weight {
    font-weight: bold;
  }
  .el-card {
    border-width: 0px;
  }
  .el-card.is-always-shadow {
    box-shadow: 0 0 0 0 rgba(0, 0, 0, 0.1);
  }
  .line {
    background: #e4e4e4;
    height: 80px;
    width: 1px;
    float: left;
    margin-top: 20px;
  }
  .table {
    margin-top: 30px;
  }
  .spacing {
    position: relative;
    width: 100%;
    height: 20px;
    background: #f0f2f5;
  }
  .box-list {
    position: relative;
    height: 110px;
    background: #f0f2f5;
    .box-card {
      position: relative;
      background-color: #ffffff;
      width: 32%;
      margin-right: 2%;
      height: 120px;
      float: left;
      .el-card__header {
        border-bottom-width: 0;
      }
      .el-card__body {
        padding: 0px;
      }
      .value {
        color: #373839;
        text-align: center;
        margin-top: 24px;
        margin-bottom: 8px;
        height: 45px;
        line-height: 45px;
        font-size: 32px;
        font-weight: 500;
      }
      .title {
        color: #666666;
        text-align: center;
        font-size: 14px;
        height: 20px;
        line-height: 20px;
      }
    }
    .box-last {
      margin-right: 0%;
    }
  }
  .chart-title {
    position: relative;
    margin-top: 30px;
    margin-left: 30px;
    height: 25px;
    font-size:18px;
    font-weight:600;
    line-height: 25px;
    color: #000000;
  }
  .chart-title-more {
    position: relative;
    width: 100%;
    height: 70px;
    p {
      position: relative;
      float: left;
      width: 400px;
      margin-top: 30px;
      margin-left: 30px;
      height: 25px;
      font-size:18px;
      font-weight:600;
      line-height: 25px;
      color: #000000;
    }
    .rank-radio {
      position: relative;
      margin: 30px 30px 0 0;
      float: right;
      .el-radio-button__inner {
        padding: 7px 29px;
      }
    }
  }
  .chart {
    position: relative;
    margin: 0 auto 0 auto;
    width: 1064px;
    height: 380px;
  }
  .chart-remarks {
    position: relative;
    height: 66px;
    padding: 20px 0 30px 30px;
    font-size: 16px;
    font-weight: 400;
    line-height: 16px;
    color: #666666;
  }
  .exam-table {
    top: 20px;
    padding: 0;
    width: 95%;
    margin:0 auto 20px auto;
    .button-jump {
      color: #449284;
    }
  }
  .pagination {
    margin-top: 30px;
    margin-right: 13px;
  }
}
</style>
